/*

This is main code that calls the functions to perform

NFC Initialization
Block Erase
Copy Back
Random Data Input
Random Data Output

*/

#include "main.h"

void main() 

{		
	//Initialize the NFC and interrupts
	Init();
			
	//API's to perform the required operation. 
	
	//Erases a Block
	BlockErase(BlockNo);

	//Writes to a byte in a page. Make sure block is erased before issuing this command
	RandomDataInput(ByteNo, PageNo, BlockNo, DataInput);
	
	//Reads a byte in a page
	RandomDataOutput(ByteNo, PageNo, BlockNo, DataOutput);
		
	
	/*
	Copies the data in SrcPageNo of SrcBlockNo to DestPageNo of DestBlockNo.
	If the data is already there in SrcPageNo, then just use CopyBackAPI.
	Else, you can use PageWrite API to write the data into SrCPageNo.
	
	
	So, for test purpose, first the SrcPageNo is written with Data 
	using PageWrite API. After CopyBack is completed, the PageRead API 
	is used to read the data from DestPageNo and these data's are 
	compared for errors.
		
	
	*/
		
	BlockErase(SrcBlockNo);
	PageWrite(SrcPageNo, SrcBlockNo, &WriteData[0]);
	//Use CopyBack API to copy a Page from SrcBlock to DestBlock
	CopyBack(SrcPageNo, SrcBlockNo, DestPageNo, DestBlockNo);
	PageRead(DestPageNo, DestBlockNo, &ReadData[0]);
	
	//do memory comparision to compare the read data from DestPageNo.
		
	for(i=0; i<Flash_Page_Size; i++)
    {
       if(ReadData[i] != WriteData[i])
       {
           printf("error %d\n", i);
           Flag2 = 1;
           break;
       }
       	
    }
    
    if(Flag2 != 1)
    {
    	printf("success\n");
    }
    
           		
}
    
